# -*- coding: utf-8 -*-
"""Copy of wise assignment 3.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1qXRnrYdSMlLwngj0FFKE-DYGr-hgYe9D
"""

#1
def longestlength(a):
    max1 = len(a[0])
    temp = a[0]

    for i in a:
        if(len(i) > max1):
            max1 = len(i)
            temp =i

    print(temp)
    print(max1)

a = ["find", "me", "if", "you", "can"]
longestlength(a)

#2
def palindrome():
  x = input("enter a string:")
  y = x[::-1]
  print("reverse of the word is " +y)
  if(x==x[::-1]):
    print("it is a palindrome")
  else:
    print("not a palindrome")
  l = int(len(x)/2)
  if x[:l]==x[l:]:
    print("string is symmetric")
  else:
    print("string is not symmetric")
palindrome()

#3
import string

def ispangram(str):
  alphabet= "abcdefghijklmnopqrstuvwxyz"
  for char in alphabet:
    if char  not in str.lower():
      return False

  return True

string = "The quick brown fox jumps over the lazy dog"  
if(ispangram(string)==True) :
    print("Yes")
else:
  print("No")

#4
def sort_hyphen(your_string):
  your_list = your_string.split('-')
  your_list.sort()
  return'-'.join(your_list)

my_string = 'green-red-yellow-black-white'
print(sort_hyphen(my_string))

#5
def isprime(n):
  for i in range(2,n):
    if(n%i) == 0:
      return False
  return True

def generatetwin(start,end):
  for i in range(start,end):
      j = i + 2
      if(isprime(i) and isprime(j)):
        print(i,j)

generatetwin(2,20)

#6
my_string = str(input("enter"))

def double(str):
  doubled = ' '
  for char in str:
    doubled+=char*2

  return doubled

print(double(my_string))

#7
a = 0
b = 1
print(a)
print(b)


for i in range(2,20):
  c = a + b
  print(c)
  a = b
  b = c

#8
n = int(input("enter the number:"))

even = 0
odd = 0
while n>0:
   if (n%10)%2==0:
     even = even + 1
   else:
     odd = odd +1
   n=n//10

print(even,odd)

#9
def perfectnum(n):
  sum = 0
  for x in range(1,n):
    if n%x == 0:
      sum += x
      return sum == n
print(perfectnum(15))

#10
string1 = " print even length words in a string"
string2 = string1.split(" ")
for i in string2:

  if len(i)%2==0:
    print(i)

#1D
n=int(input("enter the no of rows:"))
for j in range(n):
  for i in range(n-j-1):
    if i==n-j-2:
      print("1")
    print("1",end="")

#2D
s = input("enter the string:")
si = s.replace('','')
f = si.split(',')
print(f)
ffloat=[float(i) for i in f]
print(ffloat)
sum = 0.0
for i in range(0,len(ffloat)):
  sum+=ffloat[i]
print("you entered:",s,"sum:",sum)

#3D
s = int(input("enter the number:"))
c = 0
while(True):
  l=[]
  t=s
  l=[]
  while(t>0):
    l.append(t%10)
    t=t//10
  print(l)
  c=c+1
  if(len(l)==1 or l==[]):
    break;
  s=1
  for i in range(0,len(l)):
    s=s*l[i]
  print(s)
if(l!=[]):
  print("MDR is",l[0],"and M persistance is",c-1)
else:
  print("MDR is 0 and M persistance is",c-1)

#4D
n = int(input("enter the length of sideof square:"))
rad = float(input("enter the radius of circle:"))
r = round(rad,2)
s = input("enter shape CIR or SQR:")
dia = (pow(2,1/2)*n)-2*((pow(2,1/2)*r)+r)
if s == "CIR":
  area = round(3.414*dia,1)
  print(area)
else:
  area = round((dia*dia)/2,1)
  print(area)

#6D
def area(a,b,c,d,e,f):
  return abs((a*(d-f)+c*(f-b)+e*(b-d))/2.0)
n= int(input("enter n:"))
x1,y1 = int(input("enter x1:")),int(input("enter y1:"))
x2,y2= int(input("enter x2:")),int(input("enter y2:"))
x3,y3 = int(input("enter x3:")),int(input("enter y3:"))
a = area(x1,y1,x2,y2,x3,y3)
for i in range(n):
  x,y = int(input("\n enter x:")),int(input("enter y:"))
  a1 = area(x,y,x1,y1,x2,y2)
  a2 = area(x,y,x2,y2,x3,y3)
  a3 = area(x,y,x3,y3,x1,y1)
  if(a == (a1+a2+a3)):
    print("inside\n")
  else :
    print("outside\n")

#8D
num_subjects=int(input("enter the no of subjects:"))

subjects = []
students = []
marks = []
for i in range(num_subjects):
  subject_name = input("enter the name of student{}:".format(i+1))
  highest_scoring_student = input("enter the name of the highest_scoring student in{}:".format(subject_name))
  highest_score=float(input("enter the score of{}:".format(highest_scoring_student)))

  subjects.append(subject_name)
  students.append(highest_scoring_student)
  marks.append(highest_score)
print("subjects:",subjects)
print("students:",students)
print("marks:",marks)
subject_dicts=[]
for i in range(num_subjects):
  subject_dict={"subject":subjects[i],"highest_scoring_student":students[i],"highest_score":marks[i]}
  subject_dicts.append(subject_dict)

print("list of dictionaries:")
for subject_dict in subject_dicts:
  print(subject_dict)

#9D
def value(a) :
  if a == 'I':
    return 1
  if a == 'V':
    return 5
  if a == 'X':
    return 10
  if a == 'L':
    return 50
  if a == 'C':
    return 100
  if a == 'D':
    return 150
  if a=='M': 
    return 1000

s = input("enter roman number:")
n = len(s)
num = 0
for i in range(0,n,1):
  if i+1 in range(0,n):
    if value(s[i]<value(s[i+1])):
      num = value(s[i])
    else :
      num += value(s[i])
  else :
    num+=value(s[i])
print(num)

#10D
n = int(input("enter the no of elements:"))
nums = list()
for i in range(n):
  nums.append(int(input("enter:")))
val = int(input("enter the value to be deleted:"))
c = 0
for i in range(n):
 if nums[i]==val:
   c+=1
for i in range(c):
  nums.remove(val)
  nums.append('+')
  print(nums)

#11D
n = int(input("enter the no of elements:"))
digits = list()
new_digits = list()
number = 0
for i in range(n):
  x = int(input("enter the element:"))
  digits.append(x)
  number = (number*10)+digits[i]
  number+=1
while number>0:
  new_digits.append(number%10)
  number//=10
l = len(new_digits)
for i in range((l-1)//2):
  temp = new_digits[i]
  new_digits[i]=new_digits[l-i-1]
  new_digits[l-i-1]=temp
print(new_digits)